<script>
/*****************************************************************
// IBM Confidential
// OCO Source Material
// 5724-W78
// (C) Copyright IBM Corp. 2010
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has been
// deposited with the U. S. Copyright Office.
 *****************************************************************
 */

//This check can be passed as an argument to secure functions 
//in the API that you call or any secure functions you define in
//secureUserExtensions.js
var userSecurityCheck = new Function('return window');

top.postInstallationPropertiesWindowObject=null;
// To use this funtion in your content, you must refer to it as top.myFunc()
function launchpadStop() 
{
	top.logEnter( "ENTER launchpadStop", []);
    //runProgram(null,command('clean'), BACKGROUND, VISIBLE, this);
    top.logExit( "EXIT launchpadStop", []);
	top.Exit();
}

top.tpmMediaFolder="";
function initTPMMediaFolder()
{
	top.logEnter( "ENTER initTPMMediaFolder", []);
	top.tpmMediaFolder = getCookie("TPMMediaFolder");
	if( top.tpmMediaFolder == undefined || top.tpmMediaFolder.length <= 0 ) {
		top.tpmMediaFolder = top.STARTINGDIR;
		setCookie("TPMMediaFolder",top.tpmMediaFolder,30);
	}
	top.logExit( "EXIT initTPMMediaFolder", []);
}

top.srmMediaFolder="";
function initSRMMediaFolder()
{
	top.logEnter( "ENTER initSRMMediaFolder", []);
	top.srmMediaFolder = getCookie("SRMMediaFolder");
	if( top.srmMediaFolder == undefined || top.srmMediaFolder.length <= 0 ) {
		top.srmMediaFolder = top.STARTINGDIR;
		setCookie("SRMMediaFolder",top.srmMediaFolder,30);
	}
	top.logExit( "EXIT SRMMediaFolder", []);
}

top.mwiWorkspaceFolder="";
function initMWIWorkspaceFolder()
{
	top.logEnter( "ENTER initMWIWorkspaceFolder", []);
	top.mwiWorkspaceFolder = getCookie("MWIWorkspaceFolder");
	if( top.mwiWorkspaceFolder == undefined || top.mwiWorkspaceFolder.length <= 0 ) {
		top.mwiWorkspaceFolder = property('mwiWorkspaceFolderDefaultDirectory');
		setCookie("MWIWorkspaceFolder",top.mwiWorkspaceFolder,30);
	}
	top.logExit( "EXIT initMWIWorkspaceFolder", []);
}

top.tsamwasMediaFolder="";
function initTSAMWASMediaFolder()
{
	top.logEnter( "ENTER initTSAMWASMediaFolder", []);
	top.tsamwasMediaFolder = getCookie("TSAMWASMediaFolder");
	if( top.tsamwasMediaFolder == undefined || top.tsamwasMediaFolder.length <= 0 ) {
		top.tsamwasMediaFolder = top.STARTINGDIR;
		setCookie("TSAMWASMediaFolder",top.tsamwasMediaFolder,30);
	}
	top.logExit( "EXIT initTSAMWASMediaFolder", []);
}

top.isReadMiddlewareInstallPrereqs = false;
function initIsReadMiddlewareInstallPrereqs()
{
	top.logEnter( "ENTER initIsReadMiddlewareInstallPrereqs", []);
	var prereqChecked = getCookie("MiddlewareInstallPrereqs");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isReadMiddlewareInstallPrereqs = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsReadMiddlewareInstallPrereqs", []);
}
function setReadMiddlewareInstallPrereqs (isChecked)
{
	top.logEnter( "ENTER setReadMiddlewareInstallPrereqs", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isReadMiddlewareInstallPrereqs = isChecked;
	setCookie("MiddlewareInstallPrereqs",valueToSet,30);
	top.logExit( "EXIT setReadMiddlewareInstallPrereqs", []);
}

top.isReadBaseServicesInstallPrereqs = false;
function initIsReadBaseServicesInstallPrereqs()
{
	top.logEnter( "ENTER initIsReadBaseServicesInstallPrereqs", []);
	var prereqChecked = getCookie("BaseServicesInstallPrereqs");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isReadBaseServicesInstallPrereqs = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsReadBaseServicesInstallPrereqs", []);
}
function setReadBaseServicesInstallPrereqs (isChecked)
{
	top.logEnter( "ENTER setReadBaseServicesInstallPrereqs", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isReadBaseServicesInstallPrereqs = isChecked;
	setCookie("BaseServicesInstallPrereqs",valueToSet,30);
	top.logExit( "EXIT setReadBaseServicesInstallPrereqs", []);
}

top.isReadCoreComponentsInstallPrereqs = false;
function initIsReadCoreComponentsInstallPrereqs()
{
	top.logEnter( "ENTER initIsReadCoreComponentsInstallPrereqs", []);
	var prereqChecked = getCookie("CoreComponentsInstallPrereqs");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isReadCoreComponentsInstallPrereqs = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsReadCoreComponentsInstallPrereqs", []);
}
function setReadCoreComponentsInstallPrereqs (isChecked)
{
	top.logEnter( "ENTER setReadCoreComponentsInstallPrereqs", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isReadCoreComponentsInstallPrereqs = isChecked;
	setCookie("CoreComponentsInstallPrereqs",valueToSet,30);
	top.logExit( "EXIT setReadCoreComponentsInstallPrereqs", []);
}

top.isReadWebComponentsInstallPrereqs = false;
function initIsReadWebComponentsInstallPrereqs()
{
	top.logEnter( "ENTER initIsReadWebComponentsInstallPrereqs", []);
	var prereqChecked = getCookie("WebComponentsInstallPrereqs");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isReadWebComponentsInstallPrereqs = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsReadWebComponentsInstallPrereqs", []);
}
function setReadWebComponentsInstallPrereqs(isChecked)
{
	top.logEnter( "ENTER setReadWebComponentsInstallPrereqs", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isReadWebComponentsInstallPrereqs = isChecked;
	setCookie("WebComponentsInstallPrereqs",valueToSet,30);
	top.logExit( "EXIT setReadWebComponentsInstallPrereqs", []);
}

top.isReadSrmInstallPrereqs = false;
function initIsReadSrmInstallPrereqs()
{
	top.logEnter( "ENTER initIsReadSrmInstallPrereqs", []);
	var prereqChecked = getCookie("SrmInstallPrereqs");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isReadSrmInstallPrereqs = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsReadSrmInstallPrereqs", []);
}
function setReadSrmInstallPrereqs(isChecked)
{
	top.logEnter( "ENTER setReadSrmInstallPrereqs", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isReadSrmInstallPrereqs = isChecked;
	setCookie("SrmInstallPrereqs",valueToSet,30);
	top.logExit( "EXIT setReadSrmInstallPrereqs", []);
}

top.isReadTsamInstallPrereqs = false;
function initIsReadTsamInstallPrereqs()
{
	top.logEnter( "ENTER initIsReadTsamInstallPrereqs", []);
	var prereqChecked = getCookie("TsamInstallPrereqs");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isReadTsamInstallPrereqs = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsReadTsamInstallPrereqs", []);
}
function setReadTsamInstallPrereqs(isChecked)
{
	top.logEnter( "ENTER setReadTsamInstallPrereqs", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isReadTsamInstallPrereqs = isChecked;
	setCookie("TsamInstallPrereqs",valueToSet,30);
	top.logExit( "EXIT setReadTsamInstallPrereqs", []);
}

top.isCompletedPostInstallationParameters = false;
function initIsCompletedPostInstallationParameters()
{
	top.logEnter( "ENTER initIsCompletedPostInstallationParameters", []);
	var prereqChecked = getCookie("CompletedPostInstallationParameters");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isCompletedPostInstallationParameters = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsCompletedPostInstallationParameters", []);
}
function setCompletedPostInstallationParameters (isChecked)
{
	top.logEnter( "ENTER setCompletedPostInstallationParameters", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isCompletedPostInstallationParameters = isChecked;
	setCookie("CompletedPostInstallationParameters",valueToSet,30);
	top.logExit( "EXIT setCompletedPostInstallationParameters", []);
}

top.isCompletedPostInstallationProperties = false;
function initIsCompletedPostInstallationProperties()
{
	top.logEnter( "ENTER initIsCompletedPostInstallationProperties", []);
	var prereqChecked = getCookie("CompletedPostInstallationProperties");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isCompletedPostInstallationProperties = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsCompletedPostInstallationProperties", []);
}
function setCompletedPostInstallationProperties (isChecked)
{
	top.logEnter( "ENTER setCompletedPostInstallationProperties", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isCompletedPostInstallationProperties = isChecked;
	setCookie("CompletedPostInstallationProperties",valueToSet,30);
	top.logExit( "EXIT setCompletedPostInstallationProperties", []);
}

top.isCompletedPostInstallationSRM = false;
function initIsCompletedPostInstallationSRM()
{
	top.logEnter( "ENTER initIsCompletedPostInstallationSRM", []);
	var prereqChecked = getCookie("CompletedPostInstallationSRM");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isCompletedPostInstallationSRM = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsCompletedPostInstallationSRM", []);
}
function setCompletedPostInstallationSRM (isChecked)
{
	top.logEnter( "ENTER setCompletedPostInstallationSRM", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isCompletedPostInstallationSRM = isChecked;
	setCookie("CompletedPostInstallationSRM",valueToSet,30);
	top.logExit( "EXIT setCompletedPostInstallationSRM", []);
}

top.isCompletedPostInstallationCloud = false;
function initIsCompletedPostInstallationCloud()
{
	top.logEnter( "ENTER initIsCompletedPostInstallationCloud", []);
	var prereqChecked = getCookie("CompletedPostInstallationCloud");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isCompletedPostInstallationCloud = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsCompletedPostInstallationCloud", []);
}
function setCompletedPostInstallationCloud (isChecked)
{
	top.logEnter( "ENTER setCompletedPostInstallationCloud", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isCompletedPostInstallationCloud = isChecked;
	setCookie("CompletedPostInstallationCloud",valueToSet,30);
	top.logExit( "EXIT setCompletedPostInstallationCloud", []);
}

top.isCompletedPostInstallationWebservices = false;
function initIsCompletedPostInstallationWebservices()
{
	top.logEnter( "ENTER initIsCompletedPostInstallationWebservices", []);
	var prereqChecked = getCookie("CompletedPostInstallationWebservices");
	if( prereqChecked != undefined && prereqChecked.length > 0 ) {
		top.isCompletedPostInstallationWebservices = (prereqChecked == "true")?true:false;
	}
	top.logExit( "EXIT initIsCompletedPostInstallationWebservices", []);
}
function setCompletedPostInstallationWebservices (isChecked)
{
	top.logEnter( "ENTER setCompletedPostInstallationWebservices", []);
	var valueToSet = "false";
	if (isChecked) {
		valueToSet = "true";
	}
	top.isCompletedPostInstallationWebservices = isChecked;
	setCookie("CompletedPostInstallationWebservices",valueToSet,30);
	top.logExit( "EXIT setCompletedPostInstallationWebservices", []);
}

function initPostInstallationVariables()
{
	top.logEnter( "ENTER initPostInstallationVariables", []);

	top.userRootLabel = getCookieDefault( "UserRootValue", "root");
	top.userDB2Label = getCookieDefault( "UserDB2Value", "ctginst1");
	top.serverDB2Label = getCookieDefault( "ServerDB2Value", "localhost");
	top.portDB2Label = getCookieDefault( "PortDB2Value", "50005");
	top.dbnameDB2MaximoLabel = getCookieDefault( "DBnameDB2MaximoValue", "MAXDB71");
	top.schemanameDB2MaximoLabel = getCookieDefault( "SchemanameDB2MaximoValue", "maximo");
	top.userDB2MaximoLabel = getCookieDefault( "UserDB2MaximoValue", "maximo");
	top.userLDAPLabel = getCookieDefault( "UserLDAPValue", "cn=root");
	top.serverLDAPLabel = getCookieDefault( "ServerLDAPValue", "localhost");
	top.portLDAPLabel = getCookieDefault( "PortLDAPValue", "389");
	top.homeIHSLabel = getCookieDefault( "HomeIHSValue", ((isAIX())?"/usr":"/opt")+"/IBM/HTTPServer");
	top.homeWASLabel = getCookieDefault( "HomeWASValue", ((isAIX())?"/usr":"/opt")+"/IBM/WebSphere/AppServer");
	top.profileWASLabel = getCookieDefault( "ProfileWASValue", "ctgAppSrv01");
	top.cellWASLabel = getCookieDefault( "CellWASValue", "ctgCell01");
	top.cellManagerWASLabel = getCookieDefault( "CellManagerWASValue", "ctgCellManager01");
	top.nodeWASLabel = getCookieDefault( "NodeWASValue", "ctgNode01");
	top.asWASLabel = getCookieDefault( "AsWASValue", "MXServer");
	top.asWebserverLabel = getCookieDefault( "AsWebserverValue", "webserver1");
	top.asPortWASLabel = getCookieDefault( "AsPortWASValue", "9443");
	top.userWASLabel = getCookieDefault( "UserWASValue", "wasadmin");
	top.userBaseLabel = getCookieDefault( "UserBaseValue", "maxadmin");
	top.serverTPMLabel = getCookieDefault( "ServerTPMValue", "");
	top.userTIOLabel = getCookieDefault( "UserTIOValue", "tioadmin");
	top.serverMailLabel = getCookieDefault( "ServerMailLabel", "localhost");
	top.serverMaximoLabel = getCookieDefault( "ServerMaximoLabel", "localhost");
	top.emailMailLabel = getCookieDefault( "EmailMailLabel", "root@localhost");
	top.homeTPAeLabel = getCookieDefault( "HomeTPAeValue", ((isWindows())?"C:\\IBM\\SMP":"/opt/IBM/SMP"));
	
	top.logExit( "EXIT initPostInstallationVariables", []);
}

function setPostInstallationVariables()
{
	top.logEnter( "ENTER setPostInstallationVariables", []);
	
	setCookie( "UserRootValue", top.userRootLabel, 30);
	setCookie( "UserDB2Value", top.userDB2Label, 30);
	setCookie( "UserDB2MaximoValue", top.userDB2Label, 30);
	setCookie( "ServerDB2Value", top.serverDB2Label, 30);
	setCookie( "PortDB2Value", top.portDB2Label, 30);
	setCookie( "DBnameDB2MaximoValue", top.dbnameDB2MaximoLabel, 30);
	setCookie( "SchemanameDB2MaximoValue", top.schemanameDB2MaximoLabel, 30);
	setCookie( "UserLDAPValue", top.userLDAPLabel, 30);
	setCookie( "ServerLDAPValue", top.serverLDAPLabel, 30);
	setCookie( "PortLDAPValue", top.portLDAPLabel, 30);
	setCookie( "HomeIHSValue", top.homeIHSLabel, 30);
	setCookie( "HomeWASValue", top.homeWASLabel, 30);
	setCookie( "ProfileWASValue", top.profileWASLabel, 30);
	setCookie( "CellWASValue", top.cellWASLabel, 30);
	setCookie( "CellManagerWASValue", top.cellManagerWASLabel, 30);
	setCookie( "NodeWASValue", top.nodeWASLabel, 30);
	setCookie( "AsWASValue", top.asWASLabel, 30);
	setCookie( "AsWebserverValue", top.asWebserverLabel, 30);
	setCookie( "AsPortWASValue", top.asPortWASLabel, 30);
	setCookie( "UserWASValue", top.userWASLabel, 30);
	setCookie( "UserBaseValue", top.userBaseLabel, 30);
	setCookie( "ServerTPMValue", top.serverTPMLabel, 30);
	setCookie( "UserTIOValue", top.userTIOLabel, 30);
	setCookie( "HomeTPAeValue", top.homeTPAeLabel, 30);

	top.logExit( "EXIT setPostInstallationVariables", []);
}

function launchpadStartup()
{
	// If we specify the debug flag for the launchpad, also activate the trace and debug functionality of the common launchpad
	if(isTestEnvVar( "DEBUG_TSAM_LAUNCHPAD")) {
		top.logSetFilter("ESWTD");
	}
	else {
		top.logSetFilter("ESWD");
	}
	top.logEnter( "ENTER launchpadStartup", []);

    var topLevel = top.STARTINGDIR;
    var chances = 3;
	//Initialize values from cookies
	if( isUnix() ) {
		top.cookieFile = getEnv("HOME") + "/.cookies.txt";
//	} else {
//		top.cookieFile = getEnv("HOMEDRIVE") + getEnv("HOMEPATH") + "\\.cookies.txt";
	}
	initTPMMediaFolder();
	initSRMMediaFolder();
	initTSAMWASMediaFolder();
	initMWIWorkspaceFolder();
	initIsReadMiddlewareInstallPrereqs();
	initIsReadBaseServicesInstallPrereqs();
	initIsReadCoreComponentsInstallPrereqs();
	initIsReadWebComponentsInstallPrereqs();
	initIsReadSrmInstallPrereqs();
	initIsReadTsamInstallPrereqs();
	initIsCompletedPostInstallationParameters();
	initIsCompletedPostInstallationProperties();
	initIsCompletedPostInstallationSRM();
	initIsCompletedPostInstallationCloud();
	initIsCompletedPostInstallationWebservices();
	initPostInstallationVariables();

	setEnv("mwi_launchpadroot",top.tpmMediaFolder);

    if (directoryExists(NO_DISKID,topLevel+"launchpad")) {
        setEnv("lpRoot",top.tpmMediaFolder);
    } else {
        var count=0;
        while(getEnv("lpRoot") == "") {
            count++;
            // NOTE: the following cannot be NLS because properties cannot be used if launchpad root is not found
            var userDir = prompt("Unable to determine path", "Please enter the path to the launchpad image");
            if (directoryExists(NO_DISKID,userDir+"\launchpad")) {
                setEnv("lpRoot",userDir);
            } else {
                if (count == chances) {
                    alert("Can't locate source directory for installation media.  Click OK to exit.");
                    top.Exit()
                }
            }
        }
    }
    top.logExit( "EXIT launchpadStartup", []);
}

//This function will launch the supplied Middleware installer.
function runMwiInstaller()
{
	top.logEnter( "ENTER runMwiInstaller", []);
	if ( top.isReadMiddlewareInstallPrereqs)
	{
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TPM'));
		var commandPath = promptForTPMInstaller( top.tpmMediaFolder, prompt, NO_DISKID, ["install/"+command('mwi')]);
		if( commandPath != null ) {
			var popupWin = showFeedback(property( 'launchingInstallerFeedback'));
			setTimeout( function(){hideFeedback(popupWin)},5*1000);
			top.logDebug( commandPath );
			
			if(isAIX())
			{
				// This environment variable is needed for AIX 6.1 version higher than TL 4
				setEnv( "JAVA_COMPILER", "none");
			}
			
			runProgram( NO_DISKID,[commandPath], BACKGROUND, VISIBLE, this);
		}
	} else {
		alert( property('warnReadMiddlewareInstallPrereqs'));
	}
	top.logExit( "EXIT runMwiInstaller", []);
}

//--------------------- license functions      ---------------------------------------
function isLicenseInstalled() 
{
	top.logEnter( "ENTER isLicenseInstalled", []);
	var licenseInstalledFlag = false;

	if(top.findFile(NO_DISKID, getLicensePath()) != null) {
		licenseInstalledFlag = true;
	} else if (isTestEnvVar( "TSAM_LICENSE_ACCEPTED")) {
		licenseInstalledFlag = true;
	}
	top.logExit( "EXIT isLicenseInstalled", [licenseInstalledFlag]);
  	return licenseInstalledFlag;
}

function getLicensePath() 
{
	top.logEnter( "ENTER getLicensePath", []);
	if(isWindows()) {
		licensePath = getEnv("APPDATA")+"\\tsam\\license\\English.txt";
	} if(isUnix()) {
		licensePath ="/opt/IBM/tsam/license/English.txt";
	}
	top.logExit( "EXIT getLicensePath", [licensePath]);
	return licensePath;
}

function isTSAMDVD()
{
	top.logEnter( "ENTER isTSAMDVD", []);
	var myCommand = command('license');
	var cdLocation = top.STARTINGDIR;
	var installProgram = cdLocation + myCommand[0];
	var retValue = top.findFile(NO_DISKID, installProgram) || isTestEnvVar( "TSAM_DVD");
	top.logExit( "EXIT isTSAMDVD", [retValue]);
	return retValue;
}

function runLicenseInstaller(win) 
{
	top.logEnter( "ENTER runLicenseInstaller", [win]);
	var popupWin = showFeedback(property('launchingInstallerFeedback'));
	top.logTrace("setTimeout");
	setTimeout( function(){hideFeedback(popupWin)},5*1000);
	top.logDebug("Call license installer");
    runProgram( null, command('license'), FOREGROUND, VISIBLE, this, top.STARTINGDIR);
    top.logTrace("win.location.reload()");
    win.location.reload();
    top.logExit( "EXIT runLicenseInstaller", []);
}

//-----------------------end of  license functions     --------------------------------------------

function runBaseServicesInstallation()
{
	top.logEnter( "ENTER runBaseServicesInstallation", []);
	if (top.isReadBaseServicesInstallPrereqs) {
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TPM'));
		var commandPath = promptForTPMInstaller(top.tpmMediaFolder, prompt, NO_DISKID, command('ccmdb'));
		if( commandPath != null ) {
			var popupWin = showFeedback(property('launchingInstallerFeedback'));
			setTimeout( function(){hideFeedback(popupWin)},5*1000);
			top.logDebug( commandPath );
			runProgram( NO_DISKID, commandPath, BACKGROUND, VISIBLE, this);
		}
	} else {
		alert(property('warnReadBaseServicesInstallPrereqs'));
	}
	top.logExit( "EXIT runBaseServicesInstallation", []);
}

function runLanguagePackInstallation()
{
	top.logEnter( "ENTER runLanguagePackInstallation", []);
	if (top.isReadBaseServicesInstallPrereqs) {
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TPM'));
		var commandPath = promptForTPMInstaller(top.tpmMediaFolder, prompt, NO_DISKID, command('ccmdblang'));
		if( commandPath != null ) {
			var popupWin = showFeedback(property('launchingInstallerFeedback'));
			setTimeout( function(){hideFeedback(popupWin)},5*1000);
			top.logDebug( commandPath );
			runProgram( NO_DISKID, commandPath, BACKGROUND, VISIBLE, this);
		}
	} else {
		alert(property('warnReadBaseServicesInstallPrereqs'));
	}
	top.logExit( "EXIT runLanguagePackInstallation", []);
}

function runCoreComponentsInstallation()
{
	top.logEnter( "ENTER runCoreComponentsInstallation", []);
	if( top.isReadCoreComponentsInstallPrereqs ) {
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TPM'));
		var commandPath = promptForTPMInstaller(top.tpmMediaFolder, prompt, NO_DISKID, command('coreComponents'));
		if( commandPath != null ) {
			var popupWin = showFeedback(property('launchingInstallerFeedback'));
			setTimeout( function(){hideFeedback(popupWin)},5*1000);
			top.logDebug( commandPath );
			runProgram( NO_DISKID, [commandPath], BACKGROUND, VISIBLE, this);
		}
	} else {
		alert(property('warnReadCoreComponentsInstallPrereqs'));
	}
	top.logExit( "EXIT runCoreComponentsInstallation", []);
}

function runTPMPSIInstallation()
{
	top.logEnter( "ENTER runTPMPSIInstallation", []);
	if( top.isReadWebComponentsInstallPrereqs ) {
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TPM'));
		var commandPath = promptForTPMInstaller(top.tpmMediaFolder, prompt, NO_DISKID, command('webComponents'));
		if( commandPath != null ) {
			var popupWin = showFeedback(property('launchingInstallerFeedback'));
			setTimeout( function(){hideFeedback(popupWin)},5*1000);
			top.logDebug( commandPath );
			runProgram( NO_DISKID, commandPath, BACKGROUND, VISIBLE, this);
		}
	} else {
		alert(property('warnReadWebComponentsInstallPrereqs'));
	}
	top.logExit( "EXIT runTPMPSIInstallation", []);
}

function runPrepareServerScript( wasadmin, waspwd, tioadmin)
{
	top.logEnter( "ENTER runPrepareServerScript", [wasadmin, '********', tioadmin]);
	if ((wasadmin == "") || (waspwd == "") || (tioadmin == "")) {
		alert(property('specifyAllParms'));
	} else {
		var popupWin = showFeedback(property('launchingInstallerFeedback'));
		setTimeout( function(){hideFeedback(popupWin)},5*1000);
		top.logDebug( 'Run script: prepareServer '+wasadmin+' ******** '+tioadmin );
		runProgram( 'disk1', command( 'prepareServer', wasadmin, waspwd, tioadmin), BACKGROUND, VISIBLE, this, top.STARTINGDIR);
	}
	top.logExit( "EXIT runPrepareServerScript", []);
}

function runInstallScript( cmd)
{
	top.logEnter( "ENTER runInstallScript", [cmd, arguments]);
	var popupWin = showFeedback(property('launchingInstallerFeedback'));
	setTimeout( function(){hideFeedback(popupWin)},5*1000);
	
	// be more flexible. Usually we need more than one parameter.
	var commandExecution="top.runProgram( 'disk1', command( cmd";
	if( arguments.length > 1)
	{
		var x=1;
		for( x=1; x<arguments.length; x++)
		{
			commandExecution=commandExecution+", '"+escapeBackslash(arguments[x])+"'";
		}
	}
	commandExecution=commandExecution+"), BACKGROUND, VISIBLE, this, top.STARTINGDIR);"	
	top.logDebug( 'Run script: '+commandExecution+"'" );
	
	eval("top.logDebug(commandExecution);");
	eval(commandExecution);
	top.logExit( "EXIT runInstallScript", []);
}

function escapeBackslash(param)
{
	param=param.replace(/\\/g, '\\\\');
	return param;
}

top.previousPage = 'dummy';
function navigateBack()
{
	top.logEnter( "ENTER navigateBack", []);
	top.navigateTo( top.previousPage);
	top.logExit( "EXIT navigateBack", [top.previousPage]);
}
function navigateToPrepareServer( mypage)
{
	top.logEnter( "ENTER navigateToPrepareServer", [mypage]);
	top.previousPage = mypage;
	top.navigateTo('prepareServer');
	top.logExit( "EXIT navigateToPrepareServer", []);
}

function navigateToWithCheck( myPage, checkVariable, errorMsg)
{
	top.logEnter( "ENTER navigateToWithCheck", [myPage, checkVariable, errorMsg]);
	if(checkVariable) {
		top.navigateTo(myPage);
	} else {
		alert(errorMsg);
	}
	top.logExit( "EXIT navigateToWithCheck", []);
}

//--------------------- General Install functions      ----------------------------------------------
//**
// Run the installation program if the user has read the prereq page, show message otherwise
//**
function runInstallation(isReadInstallPrereqs, cmd, productName)
{
	top.logEnter( "ENTER runInstallation", [isReadInstallPrereqs, cmd, productName]);
	if (isReadInstallPrereqs) {
		var popupWin = showFeedback(property('launchingInstallerFeedback'));
		setTimeout(function(){hideFeedback(popupWin)},5*1000);
		top.logDebug( cmd );	
		runProgram(null, cmd, BACKGROUND, VISIBLE, this, top.STARTINGDIR);
	} else {
		var msg = formatmsg(property('warnInstallPrereqs'), productName);
		alert(msg);
	}
	top.logExit( "EXIT runInstallation", []);
}

//--------------------- TPM Image Library      ----------------------------------------------

function runTPMILInstallation()
{
	top.logEnter( "ENTER runTPMILInstallation", []);
	var pmp = command('psiPackageTPMIL');
	var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TSAM'));
	var pmpPath = promptForInstaller(top.STARTINGDIR, prompt, NO_DISKID, pmp);
	if(pmpPath != null) {
		pmpPath = pmpPath + pmp[0];
		top.logDebug( pmpPath );
		runInstallation( top.isReadTsamInstallPrereqs, command('psiInstaller', pmpPath), property('product_TSAM'));
	}
	top.logExit( "EXIT runTPMILInstallation", []);
}

//--------------------- TSAM functions      ----------------------------------------------

function runTSAMInstallation( psiPackage)
{
	top.logEnter( "ENTER runTSAMInstallation", [psiPackage]);
	var pmp = command(psiPackage);
	var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TSAM'));
	var pmpPath = promptForInstaller(top.STARTINGDIR, prompt, NO_DISKID, pmp);
	if(pmpPath != null) {
		pmpPath = pmpPath + pmp[0];
		top.logDebug( pmpPath );
	 	runInstallation( top.isReadTsamInstallPrereqs, command('psiInstaller', pmpPath), property('product_TSAM'));
	}
 	top.logExit( "EXIT runTSAMInstallation", []);
}

function runTSAM4WASInstallation()
{
	top.logEnter( "ENTER runTSAM4WASInstallation", []);
	var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TSAM4WAS'));
	var pmpPath = promptForTSAMWASInstaller(top.tsamwasMediaFolder, prompt, NO_DISKID, command('psiPackageTSAMWAS'));
	if( pmpPath != null ) {
		var popupWin = showFeedback(property('launchingInstallerFeedback'));
		setTimeout( function(){hideFeedback(popupWin)},5*1000);
		top.logDebug( pmpPath );
		runProgram(null, command('psiInstaller', pmpPath), BACKGROUND, VISIBLE, this, top.STARTINGDIR);
	}
	top.logExit( "EXIT runTSAM4WASInstallation", []);
}

//--------------------- SRM functions      ----------------------------------------------
function runSRMInstallation()
{
	top.logEnter( "ENTER runSRMInstallation", []);
	if (top.isReadSrmInstallPrereqs) {
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_SRM'));
		var pmpPath = promptForSRMInstaller(top.srmMediaFolder, prompt, NO_DISKID, command('psiPackageSRM'));
		if( pmpPath != null ) {
			// SRM must not install any license keys; the SRM PMPs test for this envvar and skip enablement
			// keys installation if the envvar is set (Note: the actual value of the envvar does not matter)
			setEnv( "TSAMSKIPLICENSEKEYS", "TRUE");
			var popupWin = showFeedback(property('launchingInstallerFeedback'));
			setTimeout( function(){hideFeedback(popupWin)},5*1000);
			top.logDebug( pmpPath );
			runProgram(null, command('psiInstaller', pmpPath), BACKGROUND, VISIBLE, this, top.STARTINGDIR);
		}
	} else {
		var msg = formatmsg(property('warnInstallPrereqs'), property('product_SRM'));
		alert(msg);
	}
	top.logExit( "EXIT runSRMInstallation", []);
}

//--------------------- SRM Fixpack functions      ----------------------------------------------
function runSRMFixpackInstallation()
{
	top.logEnter( "ENTER runSRMFixpackInstallation", []);
	// On Linux, the TEMP environment variable must be set to /tmp
	if( isLinux() || isAIX()) {
		top.logDebug( "export TEMP=/tmp");
		setEnv( "TEMP", "/tmp");
	}
	var baseServiceInstaller = command('psiInstallSRMFixpack');
	var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TSAM'));
	var installProgram = promptForInstaller(top.STARTINGDIR, prompt, NO_DISKID, baseServiceInstaller);
	if(installProgram != null) {
		installProgram = installProgram + baseServiceInstaller[0];
		runInstallation(top.isReadSrmInstallPrereqs, installProgram, property('product_SRM'));
	}
	top.logExit( "EXIT runSRMFixpackInstallation", []);
}

function runSRMHotfixInstallation( psiPackage)
{
	top.logEnter( "ENTER runSRMHotfixInstallation", [psiPackage]);
	var pmp = command(psiPackage);
	var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TSAM'));
	var pmpPath = promptForInstaller(top.STARTINGDIR, prompt, NO_DISKID, pmp);
	if(pmpPath != null) {
		pmpPath = pmpPath + pmp[0];
		top.logDebug( pmpPath );
	 	runInstallation( top.isReadSrmInstallPrereqs, command('psiInstaller', pmpPath), property('product_SRM'));
	}
 	top.logExit( "EXIT runSRMHotfixInstallation", []);
}

//--------------------- post-installation functions      ----------------------------------------------
top.postInstallationParametersDocument=null;
function highlightMissingParameters()
{
	top.logEnter( "ENTER highlightMissingParameters", []);
	var missingColor="#ffffcc";
	var okColor="white";
	var completeForm=top.postInstallationParametersDocument.forms["postInstallationParametersForm"];
	var everythingFilled=true;
	for(i=0;i<completeForm.elements.length;i++) {
		var myValue=completeForm.elements[i].value;
		if(myValue == "")
		{
			var myName=completeForm.elements[i].name;
			if(completeForm.elements[i].style.backgroundColor!=missingColor)
			{
				completeForm.elements[i].style.backgroundColor=missingColor;
			}
			everythingFilled=false;
		}
		else
		{
			if(completeForm.elements[i].style.backgroundColor==missingColor)
			{
				completeForm.elements[i].style.backgroundColor=okColor;
			}
		}

	}
	top.logExit( "EXIT highlightMissingParameters", [everythingFilled]);
	
	return everythingFilled;	
}

function validateInstallationParameters()
{
	top.logEnter( "ENTER validateInstallationParameters", [userRootLabel, '********', serverDB2Label, portDB2Label, userDB2Label, '********', dbnameDB2MaximoLabel, schemanameDB2MaximoLabel, userDB2MaximoLabel, '********', serverLDAPLabel, portLDAPLabel, userLDAPLabel, '********', homeIHSLabel, homeWASLabel, userWASLabel, '********', profileWASLabel, cellWASLabel, cellManagerWASLabel, nodeWASLabel, asWASLabel, asWebserverLabel, asPortWASLabel, '********', emailMailLabel, serverMailLabel, serverMaximoLabel, userBaseLabel, '********', userTIOLabel, serverTPMLabel]);
	if (userRootLabel == "" || pwRootLabel == "" || serverDB2Label == "" || portDB2Label == "" || userDB2Label == "" || pwDB2Label == "" || dbnameDB2MaximoLabel == "" || schemanameDB2MaximoLabel == "" || userDB2MaximoLabel == "" || pwDB2MaximoLabel == "" || serverLDAPLabel == "" || portLDAPLabel == "" || userLDAPLabel == "" || pwLDAPLabel == "" || homeIHSLabel == "" || homeWASLabel == "" || userWASLabel == "" || pwWASLabel == "" || profileWASLabel == "" || cellWASLabel == "" || cellManagerWASLabel == "" || nodeWASLabel == "" || asWASLabel == "" || asWebserverLabel == "" || asPortWASLabel == "" || pwSSHLabel == "" || serverMailLabel == "" || emailMailLabel == "" || serverMaximoLabel == "" || userBaseLabel == "" || pwBaseLabel == "" || userTIOLabel == "" || serverTPMLabel == "") {
		alert(property('specifyAllParms'));
	} else {
		var popupWin = showFeedback(property('launchingInstallerFeedback'));
		setTimeout( function(){hideFeedback(popupWin)},5*1000);
		// Set environment variables for the post-installation script
		setPostInstallationVariables();
		top.logDebug( 'Set Environment variable TSAM_CONFIG_HOME to \''+top.STARTINGDIR+'/install/postinstall\'' );
		setEnv( "TSAM_CONFIG_HOME", top.STARTINGDIR+'/install/postinstall' );
		top.logDebug( 'Set Environment variable SSH_USER_NAME to \''+top.userRootLabel+'\'' );
		setEnv( "SSH_USER_NAME", top.userRootLabel );
		top.logDebug( 'Set Environment variable SSH_PASSWORD to \'********\'' );
		setEnv( "SSH_PASSWORD", pwRootLabel );
		top.logDebug( 'Set Environment variable DB2ADMIN to \''+top.userDB2Label+'\'' );
		setEnv( "DB2ADMIN", top.userDB2Label );
		top.logDebug( 'Set Environment variable DB2ADMIN_PW to \'********\'' );
		setEnv( "DB2ADMIN_PW", pwDB2Label );
		top.logDebug( 'Set Environment variable DB2_SERVER to \''+top.serverDB2Label+'\'' );
		setEnv( "DB2_SERVER", top.serverDB2Label );
		top.logDebug( 'Set Environment variable DB2_PORT to \''+top.portDB2Label+'\'' );
		setEnv( "DB2_PORT", top.portDB2Label );
		top.logDebug( 'Set Environment variable DB2MAXIMODBNAME to \''+top.dbnameDB2MaximoLabel+'\'' );
		setEnv( "DB2MAXIMODBNAME", top.dbnameDB2MaximoLabel );
		top.logDebug( 'Set Environment variable DB2MAXIMOSCHEMANAME to \''+top.schemanameDB2MaximoLabel+'\'' );
		setEnv( "DB2MAXIMOSCHEMANAME", top.schemanameDB2MaximoLabel );
		top.logDebug( 'Set Environment variable DB2MAXIMOUSER to \''+top.userDB2MaximoLabel+'\'' );
		setEnv( "DB2MAXIMOUSER", top.userDB2MaximoLabel );
		top.logDebug( 'Set Environment variable DB2MAXIMOPW to \'********\'' );
		setEnv( "DB2MAXIMOPW", pwDB2MaximoLabel );
		top.logDebug( 'Set Environment variable LDAP_ADMIN_FULL to \''+top.userLDAPLabel+'\'' );
		setEnv( "LDAP_ADMIN_FULL", top.userLDAPLabel );
		top.logDebug( 'Set Environment variable LDAP_ADMIN_PW to \'********\'' );
		setEnv( "LDAP_ADMIN_PW", pwLDAPLabel );
		top.logDebug( 'Set Environment variable LDAP_SERVER to \''+top.serverLDAPLabel+'\'' );
		setEnv( "LDAP_SERVER", top.serverLDAPLabel );
		top.logDebug( 'Set Environment variable LDAP_PORT to \''+top.portLDAPLabel+'\'' );
		setEnv( "LDAP_PORT", top.portLDAPLabel );
		top.logDebug( 'Set Environment variable IHS_HOME to \''+top.homeIHSLabel+'\'' );
		setEnv( "IHS_HOME", top.homeIHSLabel );
		top.logDebug( 'Set Environment variable WAS_HOME to \''+top.homeWASLabel+'\'' );
		setEnv( "WAS_HOME", top.homeWASLabel );
		top.logDebug( 'Set Environment variable WAS_PROFILE_NAME to \''+top.profileWASLabel+'\'' );
		setEnv( "WAS_PROFILE_NAME", top.profileWASLabel );
		top.logDebug( 'Set Environment variable WAS_CELL_NAME to \''+top.cellWASLabel+'\'' );
		setEnv( "WAS_CELL_NAME", top.cellWASLabel );
		top.logDebug( 'Set Environment variable WAS_CELLMANAGER_NAME to \''+top.cellManagerWASLabel+'\'' );
		setEnv( "WAS_CELLMANAGER_NAME", top.cellManagerWASLabel );
		top.logDebug( 'Set Environment variable WAS_NODE_NAME to \''+top.nodeWASLabel+'\'' );
		setEnv( "WAS_NODE_NAME", top.nodeWASLabel );
		top.logDebug( 'Set Environment variable WAS_MXSERVER_NAME to \''+top.asWASLabel+'\'' );
		setEnv( "WAS_MXSERVER_NAME", top.asWASLabel );
		top.logDebug( 'Set Environment variable WAS_WEBSERVER_NAME to \''+top.asWebserverLabel+'\'' );
		setEnv( "WAS_WEBSERVER_NAME", top.asWebserverLabel );
		top.logDebug( 'Set Environment variable MXServer_MAXIMO_PORT to \''+top.asPortWASLabel+'\'' );
		setEnv( "MXServer_MAXIMO_PORT", top.asPortWASLabel );
		top.logDebug( 'Set Environment variable WASADMIN to \''+top.userWASLabel+'\'' );
		setEnv( "WASADMIN", top.userWASLabel );
		top.logDebug( 'Set Environment variable WASADMIN_PW to \'********\'' );
		setEnv( "WASADMIN_PW", pwWASLabel );
		top.logDebug( 'Set Environment variable SSH_PASS_PHRASE to \'********\'' );
		setEnv( "SSH_PASS_PHRASE", pwSSHLabel );
		top.logDebug( 'Set Environment variable MXE_ADMINEMAIL to \''+top.emailMailLabel+'\'' );
		setEnv( "MXE_ADMINEMAIL", top.emailMailLabel );
		top.logDebug( 'Set Environment variable MAIL_SMTP_HOST to \''+top.serverMailLabel+'\'' );
		setEnv( "MAIL_SMTP_HOST", top.serverMailLabel );
		top.logDebug( 'Set Environment variable MXE_HOSTNAME to \''+top.serverMaximoLabel+'\'' );
		setEnv( "MXE_HOSTNAME", top.serverMaximoLabel );	
		top.logDebug( 'Set Environment variable MAXADMIN to \''+top.userBaseLabel+'\'' );
		setEnv( "MAXADMIN", top.userBaseLabel );
		top.logDebug( 'Set Environment variable MAXADMIN_PW to \'********\'' );
		setEnv( "MAXADMIN_PW", pwBaseLabel );
		top.logDebug( 'Set Environment variable TPM_PROV_SERVERNAME to \''+top.serverTPMLabel+'\'' );
		setEnv( "TPM_PROV_SERVERNAME", top.serverTPMLabel );
		top.logDebug( 'Set Environment variable WASRXUSER to \''+top.userTIOLabel+'\'' );
		setEnv( "WASRXUSER", top.userTIOLabel );
		top.postInstallationPropertiesWindowObject.location.reload();				
		// Start the post-installation script
		top.logDebug( 'Run script: validateInstallationParameters' );
		runProgram( 'disk1', command( 'validateInstallationParameters'), BACKGROUND, VISIBLE, this, top.STARTINGDIR);
	}
	top.logExit( "EXIT validateInstallationParameters", []);
}

function runPostInstallScript(scriptID)
{
	top.logEnter( "ENTER runPostInstallScript", []);

	if(highlightMissingParameters())
	{
		runProgram( 'disk1', command( scriptID), BACKGROUND, VISIBLE, this, top.STARTINGDIR);
	}
	else
	{
		top.navigateTo('postInstallationParameters');
		alert(property('specifyAllParms'));
	}
	
	top.logExit( "EXIT runPostInstallScript", []);
}

/*
-- Fix problem PHYP0318AWI
-- function browseForFolder overrides a default launchpad function and therefore must be disabled here

function browseForFolder(directions) 
{
	var result = "";
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var dialog = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		dialog.init(window, directions, nsIFilePicker.modeGetFolder);
	
		// start off with the home directory
		var initialDir = Components.classes["@mozilla.org/file/directory_service;1"]
	                     .getService(Components.interfaces.nsIProperties)
	                     .get("Home", Components.interfaces.nsIFile);
		// get the root directory of home
		try {
			while (typeof initialDir.parent != 'undefined' && initialDir.parent != null && initialDir.parent.path != initialDir.path) {
			    initialDir = initialDir.parent;
			}
		} catch(e) {}
		dialog.displayDirectory = initialDir;
		if (dialog.show() == nsIFilePicker.returnOK) {
		    result = dialog.file.path;
		}
    } catch(e) {
        try {
		    var shell = new ActiveXObject("Shell.Application");
			var folder = shell.BrowseForFolder(0, directions, 1+0x10+0x1000, 0x11);
	    	var folderItem = folder.Items().item();
		    result = folderItem.Path;
		} catch(e) {}
	}
	return result;
}
*/

top.backupFolder = "";
top.bsHomeFolder = "";
function runBaseServiesHomeBackup()
{
	top.logEnter( "ENTER runBaseServiesHomeBackup", []);
	var isAbsolutePath = ((isWindows()) && (/^[A-Za-z]:/).test(top.backupFolder)) || (isUnix() && (/^[/]/).test(top.backupFolder));
	if ( isAbsolutePath ) {
	// Because of zip.exe we have to ask for the TPM deliverable here and use their bsBackup batch command to start BSI Backup
		var prompt = top.formatmsg( property('installMediaLocationDescription'), property('product_TPM'));
		var commandPath = promptForTPMInstaller(top.tpmMediaFolder, prompt, NO_DISKID, command('bsBackup', top.backupFolder, top.bsHomeFolder));
		if( commandPath != null )
		{
			var popupWin = showFeedback(property('launchingInstallerFeedback'));
			setTimeout(function(){hideFeedback(popupWin)},5*1000);
			top.logDebug(commandPath);
			top.logDebug( "Perform backup: "+top.backupFolder+", "+top.bsHomeFolder );
			runProgram('disk1', commandPath, BACKGROUND, VISIBLE, this, top.STARTINGDIR, function(rc){baseServicesHomeBackupPrompt(rc)});
		}
	} else {
		alert(property('invalidFolderPath'));
	}
	top.logExit( "EXIT runBaseServiesHomeBackup", []);
}


function baseServicesHomeBackupPrompt(rc)
{
	top.logEnter( "ENTER baseServicesHomeBackupPrompt", [rc]);
	top.logDebug( "Return from baseServicesHomeBackup: "+rc);
	if (rc == 0) {
		alert(property('backupSuccessfully'));
	} else if (rc == 10)  {
		alert(property('createBackupFolderError'));
	} else if (rc == 20)  {
		alert(property('cannotDetectBaseServicesHome'));
	} else if (rc == 30)  {
		alert(property('zipErrorBaseServicesHome'));
	} else if (rc == 40)  {
		alert(property('moveErrorBaseServicesHome'));
	}
	top.logExit( "EXIT baseServicesHomeBackupPrompt", []);
}

top.wasBackupFolder = "";
top.wasDmProfile = "";
top.wasAppProfile = "";
function runWasConfigBackup()
{
	top.logEnter( "ENTER runWasConfigBackup", []);
	if (top.wasBackupFolder == "") {
		alert(property('invalidFolderPath'));
	} else if (top.wasDmProfile == "") {
		alert(property('invalidWasDmProfile'));
	} else if (top.wasAppProfile == "") {
		alert(property('invalidWasAppProfile'));
	} else {
		var popupWin = showFeedback(property('launchingInstallerFeedback'));
		setTimeout(function(){hideFeedback(popupWin)},5*1000);
		top.logDebug( "Backup WAS config: "+top.wasBackupFolder+", "+top.wasDmProfile+", "+top.wasAppProfile);
		runProgram('disk1', command('wasConfigBackup', top.wasBackupFolder, top.wasDmProfile, top.wasAppProfile), BACKGROUND, VISIBLE, this, top.STARTINGDIR, function(rc){wasConfigBackupPrompt(rc)});
	}
	top.logExit( "EXIT runWasConfigBackup", []);
}

function wasConfigBackupPrompt(rc)
{
	top.logEnter( "ENTER wasConfigBackupPrompt", [rc]);
	top.logDebug( "Return from wasConfigBackupPrompt: "+rc);
	if (rc == 0) {
		alert(property('backupSuccessfully'));
	} else if (rc == 10)  {
		alert(property('createBackupFolderError'));
	} else if (rc == 90)  {
		alert(property('cannotDetectOS'));
	} else if (rc == 20)  {
		alert(property('cannotDetectWASHome'));
	} else if (rc == 30)  {
		alert(property('wasDmBackupError'));
	} else if (rc == 40)  {
		alert(property('wasAppBackupError'));
	}
	top.logExit( "EXIT wasConfigBackupPrompt", []);
	return;
}

function isWindows() 
{
	return ( (top.OSTYPE.toUpperCase() == 'WINDOWS' && !isTestEnvVar("TEST_AIX") && !isTestEnvVar("TEST_LINUX")) || isTestEnvVar("TEST_WINDOWS"))  ;
}

function isAIX() 
{
	return ( (top.OS.toUpperCase() == "AIX" && !isTestEnvVar("TEST_WINDOWS") && !isTestEnvVar("TEST_LINUX")) || isTestEnvVar("TEST_AIX"));
}

function isLinux() 
{
	return ( (top.OS.toUpperCase() == "LINUX" && !isTestEnvVar("TEST_AIX") && !isTestEnvVar("TEST_WINDOWS")) || isTestEnvVar("TEST_LINUX"));
}

function isZLinux() 
{
	var retValue = false;
	if ((isLinux() && (top.ARCHITECTURE == "s390x")) || isTestEnvVar("TEST_LINUX_ON_Z")) {
		retValue = true;
	}
	return retValue;
}

function isUnix() 
{
	return isAIX() || isLinux() || isZLinux();
}

function isSupportedAdminWorkstation()
{
	top.logEnter( "ENTER isSupportedAdminWorkstation", []);
	var retValue = false;
	if( isWindows() ) {
		retValue = true;
	} else if( isLinux() ) {
		if (isTestEnvVar("TEST_LINUX")) {
			retValue = true;
		} else if( top.ARCHITECTURE == "x86" || top.ARCHITECTURE == "AMD64") {
			// Allowing all versions of SuSE and RHEL but no other distributions of linux at this time.
			// User must be able to switch to any higher version of SLES or RHEL without
			// restriction of the launchpad.
			retValue = top.fileExists('/etc/SuSE-release') || top.fileExists('/etc/redhat-release');
		}
	} else if( isAIX()) {
		if (isTestEnvVar("TEST_AIX")) {
			retValue = true;
		} else {
			// Setting the default returncode to true for AIX since there is a problem with Firefox 3.5.2 on AIX setting the returncode to "undefined".	
			retValue = true;
			var returnCode = runProgram( null, command('checkAIXForAdminWorkstation'), FOREGROUND, HIDDEN );
			if( returnCode == 1 ) {
				retValue = false;
			}
		}
	}
	top.logExit( "EXIT isSupportedAdminWorkstation", [retValue]);
	return retValue;
}

function isSupportedManagementServer() 
{
	top.logEnter( "ENTER isSupportedManagementServer", []);
	var retValue = false;
	if( isLinux() || isAIX() ) {
		retValue = true;
	} else {
		retValue =  false;
	}
	top.logExit( "EXIT isSupportedManagementServer", [retValue]);
	return retValue;
}

function isSupportedMWIPlatform()
{
	top.logEnter( "ENTER isSupportedMWIPlatform", []);
	var retValue = false;
	if (isSupportedManagementServer() && ! isSLESVersion(11)) {
		retValue = true;
	}
	top.logExit( "EXIT isSupportedMWIPlatform", [retValue]);
	return retValue;
}

// Returns true if the version of SLES is equal to the parameter of this function
function isSLESVersion(versionnumber)
{
	top.logEnter( "ENTER isSLESVersion", [versionnumber]);
	
	var retValue = false;
	if(fileExists("/etc/SuSE-release")) {
		var content = readTextFile("/etc/SuSE-release");
		if(content.search("VERSION = "+versionnumber) >= 0) {
			retValue = true;
		}
	}
	
	top.logExit( "EXIT isSLESVersion", [retValue]);
	return retValue;
}

//This function is called when the user press the Verify Middleware script in pre-installation page
function runMiddlewareScript()
{
	top.logEnter( "ENTER runMiddlewareScript", []);
	//alert('debug: before runverifyMWI ...' );
	var popupWin = showFeedback(property('launchingScriptFeedback'));
	setTimeout(function(){hideFeedback(popupWin)},5*1000);
	var verificationScript=command('verifyMWI');
	if ( isTestEnvVar("TSAM_SCRIPT_TEST")) {
		verificationScript = verificationScript.concat("-d");
	}
	top.logDebug( verificationScript);
	runProgram('disk1', verificationScript, FOREGROUND, VISIBLE, this, top.STARTINGDIR, function(rc){verifyEnvCallBack(rc)});
	top.logExit( "EXIT runMiddlewareScript", []);
}


//This function is called when the user press the Verify Operating System script in pre-installation page
function runVerifyEnv()
{
	top.logEnter( "ENTER runVerifyEnv", []);
	//alert('debug: before runVerifyEnv ...' );
	var popupWin = showFeedback(property('launchingScriptFeedback'));
	setTimeout(function(){hideFeedback(popupWin)},5*1000);
	var verificationScript=command('verifyEnv');
	if ( isTestEnvVar("TSAM_SCRIPT_TEST")) {
		verificationScript = verificationScript.concat("-d");
	}
	top.logDebug( verificationScript);
	runProgram('disk1', verificationScript, FOREGROUND, VISIBLE, this, top.STARTINGDIR, function(rc){verifyEnvCallBack(rc)});
	top.logExit( "EXIT runVerifyEnv", []);
}

//This function is called when the user press the Verify Required Packages script in pre-installation page
function runVerifyPrereqPackages()
{
	top.logEnter( "ENTER runVerifyPrereqPackages", []);
	var popupWin = showFeedback(property('launchingScriptFeedback'));
	setTimeout(function(){hideFeedback(popupWin)},5*1000);
	var verificationScript=command('verifyPrereqPackages');
	if ( isTestEnvVar("TSAM_SCRIPT_TEST")) {
		verificationScript = verificationScript.concat("-d");
	}
	top.logDebug( verificationScript);
	runProgram('disk1', verificationScript, FOREGROUND, VISIBLE, this, top.STARTINGDIR, function(rc){verifyPrereqPackagesCallBack(rc)});
	top.logExit( "EXIT runVerifyPrereqPackages", []);
}

function verifyEnvCallBack(rc)
{
	top.logEnter( "ENTER verifyEnvCallBack", [rc]);
	top.logDebug( "Return from verifyEnvCallBack: "+rc);
	if (rc == 0) {
		alert(property('verifyEnvOK'));
	} else if (rc == 10)  {
		readScriptOutput(property('verifyEnvWarning'));
	} else if (rc == 20)  {
		readScriptOutput(property('verifyEnvError'));
	} else if (rc == 99)  {
		alert(property('osNoGoodForScript'));		
	} else   {
		alert(formatmsg(property('verifyEnvUnexpectedRC'), rc));
	}
	top.logExit( "EXIT verifyEnvCallBack", []);
	return;
}

function verifyPrereqPackagesCallBack(rc)
{
	top.logEnter( "ENTER verifyPrereqPackagesCallBack", [rc]);
	top.logDebug( "Return from verifyPrereqPackagesCallBack: "+rc);
	if (rc == 0) {
		var scriptOutput = top.readTextFile(property('tmpOutputScriptFile'));
		scriptOutput = "\n\n" + scriptOutput.replace( /,/g, "\n") + "\n";
		alert(formatmsg(property('verifyPrereqPackagesOK'), scriptOutput));
	} else if (rc == 20)  {
		var scriptOutput = top.readTextFile(property('tmpOutputScriptFile'));
		scriptOutput = "\n\n" + scriptOutput.replace( /,/g, "\n") + "\n";
		alert(formatmsg(property('verifyPrereqPackagesError'), scriptOutput));
	} else if (rc == 99)  {
		alert(property('osNoGoodForScript'));		
	} else   {
		alert(formatmsg(property('verifyEnvUnexpectedRC'), rc));
	}
	top.logExit( "EXIT verifyPrereqPackagesCallBack", []);
	return;
}


//**
// Test a given envvar if TRUE or FALSE.
// return boolean true if the environment variable <envVarName> is set to true (in any case, upper, lower or mixed )
// return boolean false if the environment variable is set to false (in any case, upper, lower or mixed )
// otherwise return undefined 
//**
function isTestEnvVar( envVarName) 
{
	top.logEnter( "ENTER isTestEnvVar", [envVarName]);
	var retValue = false;
	if(getEnv(envVarName).toUpperCase() == "TRUE") {
		retValue =  true;
	}
	else if(getEnv(envVarName).toUpperCase() == "FALSE") {
		retValue = false;
	}
	top.logExit( "EXIT isTestEnvVar", [retValue]);
	return retValue;
}


//**
// Read the output from the prereq script and create a displayable message.
//**
function readScriptOutput(initialMessage) 
{
	top.logEnter( "ENTER readScriptOutput", [initialMessage]);
	var messageToDisplay=initialMessage;
	var scriptOutput = top.readTextFile(property('tmpOutputScriptFile'));
	var messages = scriptOutput.split( ",");
	for (i=0; i<messages.length; i++) {
		messageToDisplay = messageToDisplay.concat( "\n"+displayMessage( messages[i] ) );
	}
	top.logDebug( messageToDisplay );
	alert( messageToDisplay );
	top.logExit( "EXIT readScriptOutput", []);
}


//**
// Function invoked on the management server to display the results from the prereq script.
// Must distinguish between Linux and AIX.
//**
function displayMessage(tag) 
{
	top.logEnter( "ENTER displayMessage", [tag]);
	var result = "";
	if(isAIX()) {
		result = displayAixMessage(tag);
	} else if (isLinux()) {
		result = displayLinuxMessage(tag);
	}
	top.logExit( "EXIT displayMessage", [result]);
	return result;
}
function displayLinuxMessage(tag) 
{
	top.logEnter( "ENTER displayLinuxMessage", [tag]);
	var msg= "";
	if(tag.indexOf("kernelparam") >= 0) {
		var parms = tag.split( "!");
		//ignore parms[0];
		msg = top.formatmsg(property('verifyEnvLinuxKernelparam'), parms[1], parms[3], parms[2]);
	}
	else if (tag.indexOf("os") >= 0){
		msg = property('verifyEnvOs');
	}
	else if (tag.indexOf("tmp") >= 0){
		msg = property('verifyEnvLinuxTmp');
	}
	else if (tag.indexOf("kernel") >= 0){
		msg = property('verifyEnvLinuxKernel');
	}
	else if (tag.indexOf("selinux") >= 0){
		msg = property('verifyEnvLinuxSelinux');
	}
	else if (tag.indexOf("userlimits") >= 0){
	    var parms = tag.split( "!");
		//ignore parms[0];
		msg = top.formatmsg(property('verifyEnvLinuxUserlimits'), parms[1]);
	}
	else if (tag.indexOf("prompt") >= 0){
		msg = property('verifyEnvLinuxPrompt');
	}
	else if (tag.indexOf("tmpperm") >= 0){
		msg = property('verifyEnvTmpMode');
	}
	else if (tag.indexOf("swap") >= 0){
		msg = property('verifyEnvLinuxSwap');
	}		
	else if (tag.indexOf("aio") >= 0){
		msg = property('verifyEnvLinuxAIO');
	}
	else if (tag.indexOf("nsswitch") >= 0){
		msg = property('verifyEnvLinuxNsswitch');
	}
	else if (tag.indexOf("homeDir") >= 0){
		msg = property('verifyEnvHomeDir');
	}
	else {
		msg = top.formatmsg(property('verifyEnvUnexpectedOutput'), tag);
	}
	top.logExit( "EXIT displayLinuxMessage", [msg]);
	return msg;
}
function displayAixMessage(tag) 
{
	top.logEnter( "ENTER displayAixMessage", [tag]);
	if (tag.indexOf("os") >= 0){
		msg = property('verifyEnvOs');
	}
	else if (tag.indexOf("tmp") >= 0){
		msg = property('verifyEnvTmpMode');
	}
	else if (tag.indexOf("automount") >= 0){
		msg = property('verifyEnvAixAutomount');
	}
	else if (tag.indexOf("pagingspace") >= 0){
		msg = property('verifyEnvAixPagingspace');
	}
	else if (tag.indexOf("maxprocperuser") >= 0){
		msg = property('verifyEnvAixMaxprocperuser');
	}
	else if (tag.indexOf("largefilesizes") >= 0){
		var parms = tag.split( "!"); //parseString(tag, "!");
		msg = top.formatmsg(property('verifyEnvAixLargefilesizes'), parms[1]);;
	}
	else if (tag.indexOf("userlimits") >= 0){
		msg = property('verifyEnvAixUserlimits');
	}
	else if (tag.indexOf("prompt") >= 0){
		msg = property('verifyEnvAixPrompt');
	}
	else if (tag.indexOf("aio") >= 0){
		msg = property('verifyEnvAixAIO');
	}
	else if (tag.indexOf("localModule") >= 0){
		msg = property('verifyEnvAixLocalModule');
	}
	else if (tag.indexOf("homeDir") >= 0){
		msg = property('verifyEnvHomeDir');
	}
	else {
		msg = top.formatmsg(property('verifyEnvUnexpectedOutput'), tag);
	}
	top.logExit( "EXIT displayAixMessage", [msg]);
	return msg;
}

function setCookie( name, value, expiredays)
{
	top.logEnter( "ENTER setCookie", [name, value, expiredays]);
	if( isWindows() ) {
		setCookieforWindows(name, value, expiredays);
	} else {
		setCookieforUnix(name, value, expiredays);
	}
	top.logExit( "EXIT setCookie", []);
}

function getCookie(name)
{
	top.logEnter( "ENTER getCookie", [name]);
	var result = "";
	if( isWindows() ) {
		result = getCookieforWindows(name);
	} else {
		result = getCookieforUnix(name);
	}
	top.logExit( "EXIT getCookie", [result]);
	return result;
}

function getCookieDefault(name, defaultValue)
{
	top.logEnter( "ENTER getCookieDefault", [name, defaultValue]);

	var result = getCookie(name);

	if( result == undefined || result.length == 0)
	{
		result=defaultValue;
	}

	top.logExit( "EXIT getCookieDefault", [result]);
	return result;
}

function setCookieforWindows(name, value, expiredays)
{
	top.logEnter( "ENTER setCookieforWindows", [name, value, expiredays]);
	var expDate = new Date();
	expDate.setDate(expDate.getDate()+expiredays);
	if( expiredays != undefined ) {
		document.cookie = name + "=" + escape(value) + ";expires=" + expDate.toGMTString();
	} else {
		document.cookie = name + "=" + escape(value);
	}
	top.logExit( "EXIT setCookieforWindows", []);
}

function getCookieforWindows(name)
{
	top.logEnter( "ENTER getCookieforWindows", [name]);
	var result = "";
	if( document.cookie.length > 0 ) {
		start=document.cookie.indexOf(name + "=");
		if( start != -1 ) {
			start = start + name.length+1;
			end = document.cookie.indexOf(";",start);
			if( end == -1 ) {
				end = document.cookie.length;
			}
			result = unescape(document.cookie.substring(start,end));
		}
	}
	top.logExit( "EXIT getCookieforWindows", [result]);
	return result;
}

function setCookieforUnix(name, value, expiredays)
{
	top.logEnter( "ENTER setCookieforUnix", [name, value, expiredays]);
	var allCookieString = "";
	var cookie = "";
	if( top.fileExists(top.cookieFile) ) {
		var tmpCookieString = top.readTextFile(top.cookieFile);
		if( tmpCookieString != null ) {
			var cookies = tmpCookieString.split( "|");
			for( i=0; i<cookies.length; i++ ) {
				var elements = cookies[i].split("=");
				if( elements[0] != name ) {
					allCookieString = allCookieString + "|" + cookies[i];
				}
			}
		}
	}
	if( expiredays != undefined ) {
		var expDate = new Date();
		expDate.setDate(expDate.getDate()+expiredays);
		cookie = name + "=" + escape(value) + ";expires=" + expDate.toGMTString();
	} else {
		cookie = name + "=" + escape(value);
	}
	if( allCookieString.length > 0 ) {
		allCookieString = allCookieString + "|" + cookie;
	} else {
		allCookieString = cookie;
	}
	top.writeTextFile(top.cookieFile, allCookieString);
	top.logExit( "EXIT setCookieforUnix", []);
}

function getCookieforUnix(name)
{
	top.logEnter( "ENTER getCookieforUnix", [name]);
	var result = "";
	if( top.fileExists(top.cookieFile) ) {
		var tmpCookieString = top.readTextFile(top.cookieFile);
		if( tmpCookieString != null ) {		
			var cookies = tmpCookieString.split( "|");
			for( i=0; i<cookies.length; i++ ) {
				var elements = cookies[i].split("=");
				if( elements.length > 1 && elements[0] == name ) {
					var	index = elements[1].indexOf(";");
					if( index == -1 ) {
						result = unescape(elements[1]);
					} else {
						result = unescape(elements[1].substring(0,index));
					}
				}
			}
		}
	}
	top.logExit( "EXIT getCookieforUnix", [result]);
	return result;
}

function activateLinkOnAdminServer()
{
	top.logEnter( "ENTER activateLinkOnAdminServer", []);
	var retValue = "";
	if ( isSupportedAdminWorkstation() == false) {
		retValue = "<p><%= property('performOnAdminServer') %></p>";
	} else {
		retValue = "<p><%= property('enableLinkIfLicenseInstalled') %></p>";
	}
	top.logExit( "EXIT activateLinkOnAdminServer", [retValue]);
	return retValue;
}

function activateLinkOnManagementServer()
{
	top.logEnter( "ENTER activateLinkOnManagementServer", []);
	var retValue = "";
	// The string about the licence is only shown if we are on the TSAM DVD
	if ( isSupportedManagementServer() == false) {
		retValue = "<p><%= property('performOnManagementServer') %></p>";
	} else {
		retValue = "<p><%= property('enableLinkIfLicenseInstalled') %></p>";
	}
	top.logExit( "EXIT activateLinkOnManagementServer", [retValue]);
	return retValue;
}

function promptForMiddlewareWorkspace(startingDir, prompt, disk, command)
{
	top.logEnter( "ENTER promptForMiddlewareWorkspace", [startingDir, prompt, disk, command]);
	var cdLocation = startingDir;
	var myCommand = command[0];
	var installProgram = cdLocation + myCommand;
   
	cdLocation = promptForInstaller(startingDir, prompt, disk, command);
   	var finalCmd = "";
	if( cdLocation != null ) {
	    finalCmd = cdLocation;
		setCookie("MWIWorkspaceFolder",top.mwiWorkspaceFolder,30);
	} else {
		finalCmd = null;
	}
	top.logExit( "EXIT promptForMiddlewareWorkspace", [finalCmd]);
	return finalCmd;
   
}

function promptForTPMInstaller(startingDir, prompt, disk, command)
{
	top.logEnter( "ENTER promptForTPMInstaller", [startingDir, prompt, disk, command]);
	var cdLocation = startingDir;
	var installProgram = cdLocation + command[0];
   
	cdLocation = promptForInstaller(startingDir, prompt, disk, command);
   
   	var finalCmd = [];
	if( cdLocation != null ) {
		installProgram = cdLocation + command[0];
		command.shift();
		finalCmd = finalCmd.concat(installProgram, command);
		top.tpmMediaFolder = cdLocation;
		setCookie("TPMMediaFolder",top.tpmMediaFolder,30);
        setEnv("mwi_launchpadroot",top.tpmMediaFolder+"install");
        setEnv("lpRoot",top.tpmMediaFolder);
	} else {
		finalCmd = null;
	}
	top.logExit( "EXIT promptForTPMInstaller", [finalCmd]);
	return finalCmd;
   
}

function promptForSRMInstaller(startingDir, prompt, disk, command)
{
	top.logEnter( "ENTER promptForSRMInstaller", [startingDir, prompt, disk, command]);
	var cdLocation = startingDir;
	var installProgram = cdLocation + command[0];
   
	cdLocation = promptForInstaller(startingDir, prompt, disk, command);
   
   	var finalCmd = "";
	if( cdLocation != null ) {
		installProgram = cdLocation + command[0];
		command.shift();
		finalCmd = finalCmd.concat(installProgram, command);
		top.srmMediaFolder = cdLocation;
		setCookie("SRMMediaFolder",top.srmMediaFolder,30);
	} else {
		finalCmd = null;
	}
	top.logExit( "EXIT promptForSRMInstaller", [finalCmd]);
	return finalCmd;
   
}

function promptForTSAMWASInstaller(startingDir, prompt, disk, command)
{
	top.logEnter( "ENTER promptForTSAMWASInstaller", [startingDir, prompt, disk, command]);
	var cdLocation = startingDir;
	var installProgram = cdLocation + command[0];
   
	cdLocation = promptForInstaller(startingDir, prompt, disk, command);
   
   	var finalCmd = "";
	if( cdLocation != null ) {
		installProgram = cdLocation + command[0];
		command.shift();
		finalCmd = finalCmd.concat(installProgram, command);
		top.tsamwasMediaFolder = cdLocation;
		setCookie("TSAMWASMediaFolder",top.tsamwasMediaFolder,30);
	} else {
		finalCmd = null;
	}
	top.logExit( "EXIT promptForTSAMWASInstaller", [finalCmd]);
	return finalCmd;
   
}

function promptForInstaller(startingDir, prompt, disk, command)
{	
	top.logEnter( "ENTER promptForInstaller", [startingDir, prompt, disk, command]);
	var cdLocation = startingDir;
	
	if (!diskValidator( cdLocation, command, disk)) {
		//if we can't find it already, ask the user for the appropriate location
		var keepLooping = true;
		while (keepLooping) {
			cdLocation = top.modalPromptWithBrowse(property('promptTitle'), prompt, cdLocation, top.isDirOK, 460, 400);
			if (cdLocation != null) {
				if (isWindows()) {
					if (cdLocation.substring(cdLocation.length-1) != '\\') {
						cdLocation = cdLocation + '\\';
					}
				} else {
					if (cdLocation.substring(cdLocation.length-1) != '/') {
						cdLocation = cdLocation + '/';
					}
				}
				keepLooping = (!diskValidator(cdLocation, command, disk));
			} else {
				keepLooping = false;
			}
		}
	}
	top.logExit( "EXIT promptForInstaller", [cdLocation]);
	return cdLocation;
}

//Validates the path for the third party disk.
function diskValidator(cdLocation, command, disk)
{
	top.logEnter( "ENTER diskValidator", [cdLocation, command, disk]);
	var valid = false;
	var installProgram = cdLocation + command[0];
	installProgram = top.getNativeFileName(installProgram);

	//either the path to the installer is valid, or the user pressed cancel
	if( top.findFile(disk,installProgram) != null ) {
		valid = true;
	}
	top.logExit( "EXIT diskValidator", [valid]);
	return valid;
}

// replace %x tags in messages with defined product names
function fillProductNames(message)
{
	formatedMessage = top.formatmsg(message, property('product_TSAM'), property('product_TPM'), property('product_SRM'), property('product_TPAE'), property('product_DB2'), property('product_IHS'), property('product_ITDS'), property('product_WAS'), property('product_ITM'));
	return formatedMessage;
}

function showFeedback(message)
{
	top.logEnter( "ENTER showFeedback", [message]);

	var popupWindow = window.open('emptyPage.html','WaitPage','width=300,height=100,toolbar=No,location=No,scrollbars=No,status=No,resizable=No,fullscreen=No');

	//HTML page is like
	//<html>
	//	<head>
	//	</head>
	//	<body>
	//		<table>
	//			<tbody>
	//				<tr>
	//					<td>
	//						<table>
	//							<tbody>
	//								<tr>
	//									<td><img src="./images/waiting.gif" alt="<%= property('waitIcon') %>"/></td>
	//									<td><%=property('waitMessage')%></td>
	//								</tr>
	//							</tbody>
	//						</table> 
	//					</td>
	//				</tr>
	//				<tr>
	//					<td><%=property('windowWillDieappear')%></td>
	//				</tr>
	//			</tbody>
	//		</table> 
	//	</body>
	//</html>
	var html = '<html><head><title>'+property('windowPopupTitle')+'</title></head><body>';
	html += '<table><tbody><tr><td><table><tbody><tr><td><img src="images/ac16_processing_anim.gif" alt="';
	html += property('waitIcon');
	html += '"/></td><td>';
	html += message;
	html += '</td></tr></tbody></table></td></tr><tr><td>';
	html += property('windowWillDieappear');
	html += '</td></tr></tbody></table>';
	html += '</body></html>';

	top.logTrace( "Adding runtime generated HTML page" );
	popupWindow.document.open();
	popupWindow.document.write(html);
	popupWindow.document.close();
	top.logExit( "EXIT showFeedback", [popupWindow]);

	return popupWindow;
}

function hideFeedback(popupWindow)
{
	top.logEnter( "ENTER diskValidator", [popupWindow]);
	popupWindow.close();
	top.logExit( "EXIT diskValidator", []);
}

// for preliminary information only; therefore no need to localize
function notImplemented()
{
	top.logEnter( "ENTER notImplemented", []);
	alert("This function is not implemented yet.");
	top.logExit( "EXIT notImplemented", []);
}

</script>
