#!/bin/bash
##################################################################
# Licensed Materials - Property of IBM
# 5724-W78
# (C) Copyright IBM Corp. 2010
# All Rights Reserved
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
##################################################################

#
# Name: stopWAS.sh
#
# This script is called by "configureTSAM.sh" and by "configureMaxProperties.sh"
# This script is not called directly by the user.
# It is not recommended to call this script directly
#
# Stops WebSphere (i.e. stop TIO stack except the TIO lwi):
# WebSphere Application Server server1
# WebSphere Application Server MXServer
# WebSphere Nodeagent
# WebSphere Deployment manager

workDir=`dirname "$0"`
. "$workDir/setupEnv.sh"

echo "su - $WASRXUSER -c \"\$TIO_HOME/tools/tio.sh stop -w $WASADMIN ********\""
su - $WASRXUSER -c "\$TIO_HOME/tools/tio.sh stop -w $WASADMIN $WASADMIN_PW"
RC=$?

exit $RC
